using System;
using System.Collections;
using SmartClientCommBusinessLayer;
using SmartClientCommDataAccess;

namespace RemotingMiddleTier
{
	public class RemotingServiceShim : MarshalByRefObject, IServiceObject
   {
      #region IServiceObject Members

      public EmployeeDataSet GetEmployees(out long timeTicks)
      {
         long start = DateTime.Now.Ticks;
         ServiceObject so = new ServiceObject();
         EmployeeDataSet data = so.GetEmployees();
         long end = DateTime.Now.Ticks;
         timeTicks = end - start;
         return data;
      }

      public SimpleSalesData GetSimpleSalesData(out long timeTicks)
      {
         long start = DateTime.Now.Ticks;
         ServiceObject so = new ServiceObject();
         SimpleSalesData data = so.GetSimpleSalesData();
         long end = DateTime.Now.Ticks;
         timeTicks = end - start;
         return data;
      }

      public int Add(int a, int b, out long timeTicks)
      {
         long start = DateTime.Now.Ticks;
         ServiceObject so = new ServiceObject();
         int val = so.Add(a,b);
         long end = DateTime.Now.Ticks;
         timeTicks = end - start;
         return val;
      }

      public void ComputeDiscountedRedProductSales(out long timeTicks)
      {
         long start = DateTime.Now.Ticks;
         ServiceObject so = new ServiceObject();
         so.ComputeDiscountedRedProductSales();
         long end = DateTime.Now.Ticks;
         timeTicks = end - start;
      }

      public SalesOrderDetail[] GetSalesDetailCollection(out long timeTicks)
      {
         long start = DateTime.Now.Ticks;
         ServiceObject so = new ServiceObject();
         SalesOrderDetail[] res = so.GetSalesDetailCollection();
         long end = DateTime.Now.Ticks;
         timeTicks = end - start;
         return res;
      }

      #endregion
   }
}
